import { fromEnv, runComputation } from './computation';
import { resumeLater, runResume } from './env';
export const zip = (...cs) => fromEnv((c) => resumeLater(k => {
    let remaining = cs.length;
    const results = Array(remaining);
    const cancels = cs.map((computation, i) => runResume(runComputation(computation)(c), (x) => {
        results[i] = x;
        if (--remaining === 0)
            k(results);
    }));
    return () => cancels.forEach(c => c());
}));
export const race = (...cs) => fromEnv((c) => resumeLater(k => {
    const cancelAll = () => cancels.forEach(c => c());
    const cancels = cs.map((computation) => runResume(runComputation(computation)(c), (x) => {
        cancelAll();
        k(x);
    }));
    return cancelAll;
}));
//# sourceMappingURL=array.js.map