export declare type Env<C, A> = (c: C) => Resume<A>;
export interface Pure<A> extends Env<void, A> {
}
export declare type Use<E, CP> = E extends Env<infer C, infer A> ? CP extends C ? Pure<A> : C extends CP ? Env<Omit<C, keyof CP>, A> : E : E;
export declare type Capabilities<E> = U2I<CapabilitiesOf<E>>;
declare type U2I<U> = (U extends any ? (k: U) => void : never) extends ((k: infer I) => void) ? I : never;
declare type CapabilitiesOf<E> = E extends Env<infer C, any> ? C : never;
export declare const pureEnv: <A>(a: A) => Pure<A>;
export declare const chainEnv: <C1, C2, A, B>(e: Env<C1, A>, f: (a: A) => Env<C2, B>) => Env<C1 & C2, B>;
export declare type Resume<A> = {
    now: true;
    value: A;
} | {
    now: false;
    run: (k: (a: A) => void) => Cancel;
};
export declare type Cancel = () => void;
export declare const uncancelable: () => void;
export declare const resumeNow: <A>(value: A) => Resume<A>;
export declare const resumeLater: <A>(run: (k: (a: A) => void) => Cancel) => Resume<A>;
export declare const runResume: <A>(ra: Resume<A>, k: (a: A) => void) => Cancel;
export declare const chainResume: <A, B>(ra: Resume<A>, f: (a: A) => Resume<B>) => Resume<B>;
export {};
